 
      function  runif(idum)
      implicit double precision (a-h,o-z)
      parameter (ia=16807,im=2147483647,am=1./im,iq=127773,ir=2836,
     + ntab=32,ndiv=1+(im-1)/ntab,eps=0.00000012,rnmx=1.-eps)
      integer iv(ntab),iy
      save iv,iy
      data iv /ntab*0/, iy /0/
      if(idum.le.0.or.iy.eq.0) then
      idum=max(-idum,1)
      do 20 j=ntab+8,1,-1
      k=idum/iq
      idum=ia*(idum-k*iq)-ir*k
      if(idum.lt.0) idum=idum+im
      if(j.le.ntab) iv(j)=idum
 20   continue
      iy=iv(1)
      endif
      k=idum/iq
      idum=ia*(idum-k*iq)-ir*k
      if(idum.lt.0) idum=idum+im
      j=1+iy/ndiv
      iy=iv(j)
      iv(j)=idum
      runif=min(am*iy,rnmx)
      return
      end

      function  rnorm(idum)
      implicit double precision (a-h,o-z)
      save iset,gset
      data iset/0/
      if(iset.eq.0) then
 1    v1=2.*runif(idum)-1.
      v2=2.*runif(idum)-1.     
      rsq=v1**2+v2**2
      if(rsq.ge.1..or.rsq.eq.0.) goto 1      
      fac=dsqrt(-2.*dlog(rsq)/rsq)
      gset=v1*fac
      rnorm=v2*fac
      iset=1
      else
       rnorm=gset
       iset=0
      endif
      return
      end

      subroutine jitter(idum1,idum2,n,x)

c    .. adds a random noise to x

c    .. inputs:
c    .. x is a numerical vector
c    .. n is the length of x

c    .. output:
c            x + runif(length(x),  - z, z)
c    .. x is the input vector x + a random noise 

      implicit double precision (a-h, o-z)      
      dimension x(n,2)

      xmin=99999999d0
      xmax=-99999999d0
      ymin=99999999d0
      ymax=-99999999d0
      do 5 i=1,n
         if (x(i,1).lt.xmin) xmin=x(i,1)
         if (x(i,2).lt.ymin) ymin=x(i,2)
         if (x(i,1).gt.xmax) xmax=x(i,1)
         if (x(i,2).gt.ymax) ymax=x(i,2)
 5       continue
         z1=xmax-xmin
         z2=ymax-ymin
         z1=(z1/110)
         z2=(z2/110)
         write(6,90) xmin, xmax, ymin, ymax, z1, z2
 90      format(6f10.1)
 92      format(2i10,4f10.1)
c      call g05ccf could use this if I was using Fortran only
         isum=0
      do 10 i=1,(n-1)
         do 20 j=(i+1),n
            if(x(i,1).eq.x(j,1) .and. x(i,2).eq.x(j,2)) goto 6
            goto 20
 6          idum1=runif(idum1)
            u1=(-z1+2*z1*idum1)
c            write(6,90) i,j,x(i,1),x(i,2),x(j,1),x(j,2)
c 91         format(6i10)
            x(j,1) = x(j,1)+u1
            idum2=runif(idum2)
            u1=(-z2+2*z2*idum2)
            x(j,2)= x(j,2)+u1
            write(6,92) i,j,x(i,1),x(i,2),x(j,1),x(j,2)
            isum=isum+1
 20      continue 
 10   continue
      write(6,93) isum
 93   format(1i10)
      return 
      end
      








