kdebig2<-function(h, x, y, poly, kernel = "normal", grid = F, inpoly = NA, rings = 10, 
	npt = 10 * rings)
{
# Julia Kelsall

	nx <- length(x)
	ny <- length(y)
	if(h == Inf) {
		if(grid == T) {
			ans <- matrix(1, nrow = nx, ncol = ny)
		}
		else {
			ans <- rep(1, nx)
		}
	}
	else {
		rect <- F
		if(length(poly[, 1] == 4)) {
			if((poly[1, 1] == poly[2, 1]) & (poly[2, 2] == poly[3, 
				2]) & (poly[3, 1] == poly[4, 1]) & (poly[4, 2] == 
				poly[1, 2])) {
				rect <- T
			}
			if((poly[1, 2] == poly[2, 2]) & (poly[2, 1] == poly[3, 
				1]) & (poly[3, 2] == poly[4, 2]) & (poly[4, 1] == 
				poly[1, 1])) {
				rect <- T
			}
		}
		if(rect == T) {
			xmin <- min(poly[, 1])
			xmax <- max(poly[, 1])
			ymin <- min(poly[, 2])
			ymax <- max(poly[, 2])
			if(kernel == "normal") {
				if(grid == F) {
				  edgex <- pnorm(xmax, x, h) - pnorm(xmin, x, h
				    )
				  edgey <- pnorm(ymax, y, h) - pnorm(ymin, y, h
				    )
				  ans <- edgex * edgey
				}
				if(grid == T) {
				  ex <- pnorm(xmax, x, h) - pnorm(xmin, x, h)
				  ey <- pnorm(ymax, y, h) - pnorm(ymin, y, h)
				  edgex <- matrix(ex, nrow = nx, ncol = ny)
				  edgey <- matrix(ey, nrow = nx, ncol = ny, 
				    byrow = T)
				  ans <- edgex * edgey
				}
			}
			if(kernel == "quartic") {
				if(grid == F) {
				  if(!is.loaded(symbol.For("kdesr9"))) {
				    dyn.load(
				      "/home/morrisse/libjek/Binreg/Bazza/kdesr9.o")
				  }
				  result <- .Fortran("kdesr9",
				    h = as.single(h),
				    x = as.single(x),
				    y = as.single(y),
				    nx = as.integer(nx),
				    xmin = as.single(xmin),
				    xmax = as.single(xmax),
				    ymin = as.single(ymin),
				    ymax = as.single(ymax))
				  ans <- result$x
				}
				if(grid == T) {
				  if(!is.loaded(symbol.For("kdesr10"))) {
				    dyn.load(
				      "/home/morrisse/libjek/Binreg/Bazza/kdesr10.o")
				  }
				  zmat <- matrix(1, nrow = nx, ncol = ny)
				  storage.mode(zmat) <- "single"
				  result <- .Fortran("kdesr10",
				    h = as.single(h),
				    x = as.single(x),
				    y = as.single(y),
				    nx = as.integer(nx),
				    ny = as.integer(ny),
				    xmin = as.single(xmin),
				    xmax = as.single(xmax),
				    ymin = as.single(ymin),
				    ymax = as.single(ymax),
				    zmat = zmat)
				  ans <- result$zmat
				}
			}
		}
		if(rect == F) {
			m <- rings
			r <- (1:m)
			if(kernel == "normal") {
				r <- h * sqrt(-2 * log((r - 0.5)/m))
			}
			if(kernel == "quartic") {
				r <- h * sqrt(8 * (1 - ((r - 0.5)/m)^(1/3)))
			}
			px <- c(poly[, 1], poly[1, 1])
			py <- c(poly[, 2], poly[1, 2])
			np <- length(px)
			inpol <- !is.na(inpoly[1])
			if(grid == F) {
				nx <- length(x)
				ans <- rep(NA, nx)
				lpin1 <- inout(cbind(x, y), poly)
				if(inpol) {
				  lpin2 <- inout(cbind(x, y), inpoly)
				}
				else {
				  lpin2 <- rep(F, nx)
				}
				if(!is.loaded(symbol.For("dranget"))) {
				  dyn.load("/home/morrisse/libjek/Binreg/Bazza/rands.o")
				}
				if(!is.loaded(symbol.For("imp"))) {
				  dyn.load("/home/morrisse/libjek/Binreg/Bazza/imp.o")
				}
				if(!is.loaded(symbol.For("kdesr7"))) {
				  dyn.load("/home/morrisse/libjek/Binreg/Bazza/kdesr7.o")
				}
				result <- .Fortran("kdesr7",
				  h = as.single(h),
				  x = as.single(x),
				  y = as.single(y),
				  nx = as.integer(nx),
				  lpin1 = as.logical(lpin1),
				  px = as.single(px),
				  py = as.single(py),
				  np = as.integer(np),
				  lpin2 = as.logical(lpin2),
				  radii = as.single(r),
				  m = as.integer(m),
				  npts = as.integer(npt))
				ans <- result$x
				ans[ans == 0] <- NA
			}
			if(grid == T) {
				ans <- matrix(nrow = nx, ncol = ny)
				xyvec <- cbind(rep(x, ny), rep(y, rep(nx, ny)))
				lpmat1 <- matrix(inout(xyvec, poly), nrow = nx, 
				  ncol = ny, byrow = F)
				if(inpol) {
				  lpmat2 <- matrix(inout(xyvec, inpoly), nrow
				     = nx, ncol = ny, byrow = F)
				}
				else {
				  lpmat2 <- matrix(F, nx, ny)
				}
				zmat <- matrix(1, nrow = nx, ncol = ny)
				storage.mode(zmat) <- "single"
				storage.mode(lpmat1) <- "logical"
				storage.mode(lpmat2) <- "logical"
#bazzes fix

				if(!is.loaded(symbol.For("kdesr8")))
				  {
#dyn.load(c"/home/morrisse/libjek/Binreg/Bazza/kdesr8.o","/home/morrisse/libjek/Binreg/Bazza/imp.o","/home/morrisse/libjek/Binreg/Bazza/rands.o"))
				    dyn.load('/home/morrisse/libjek/Binreg/Bazza/rands.o')
				    dyn.load('/home/morrisse/libjek/Binreg/Bazza/imp.o')
				    dyn.load('/home/morrisse/libjek/Binreg/Bazza/kdesr8.o')
				  }
#				if(!is.loaded("_dranget_")) {
#				  dyn.load2("/home/7g/mab019/Splancs/rands.o")
#				}
#				if(!is.loaded("_imp_")) {
#				  dyn.load2("/home/7g/mab019/Splancs/imp.o")
#				}
#				if(!is.loaded("_kdesr8_")) {
#				  dyn.load2("/home/7g/mab019/Splancs/kdesr8.o")
#				}
				result <- .Fortran("kdesr8",
				  h = as.single(h),
				  x = as.single(x),
				  y = as.single(y),
				  nx = as.integer(nx),
				  ny = as.integer(ny),
				  lpmat1 = as.logical(lpmat1),
				  px = as.single(px),
				  py = as.single(py),
				  np = as.integer(np),
				  lpmat2 = as.logical(lpmat2),
				  radii = as.single(r),
				  m = as.integer(m),
				  npts = as.integer(npt),
				  zmat = zmat)
				ans <- result$zmat
				ans[ans == 0] <- NA
			}
		}
	}
	ans
}
