

      subroutine kdesr(h,rx,ry,nr,x,nx,y,ny,t,zmat)

c    .. calculates spatial kernel density estimation with normal kernel
c         at nx*ny points on grid (x,y)

c    .. inputs:
c    .. h is bandwidth
c    .. (rx,ry) is data
c    .. nr is no of data points
c    .. x is x-values of grid on which to compute estimate
c    .. y is y-values of grid on which to compute estimate
c    .. nx is length of x   
c    .. ny is length of y   
c    .. t is lifetime vector

c    .. output:
c    .. zmat contains density estimates at grid points

      implicit real (a-h, o-z)      
      parameter (pi=real(3.141592653589793116))
      dimension rx(nr),ry(nr),x(nx),y(ny),t(nr),zmat(nx,ny)

      do 10 i=1,nx
        do 20 j=1,ny 
          totaln=0.0
          totald=0.0
          do 30 k=1,nr
            sqdist=(x(i)-rx(k))**(2.0)+(y(j)-ry(k))**(2.0)
            changed=exp(-0.5*sqdist/(h**2.0) )
            changen=changed*t(k)
            totald=totald+changed
            totaln=totaln+changen
30        continue 
          zmat(i,j)=totaln/totald
20      continue        
10    continue 

      return 
      end

