

      subroutine kern(h,x,y,nr,evalx,evaly,n,zmat)

c    .. calculates spatial kernel density estimation with normal kernel
c         at nx*ny points on grid (evalx,evaly)

c    .. inputs:
c    .. h: bandwidth
c    .. (x,y): data coordinates
c    .. nr=length(rx): # data points
c    .. evalx: x-values of grid on which to compute estimate
c    .. evaly: y-values of grid on which to compute estimate
c    .. n=length(evalx): is no of evaluation points

c    .. output:
c            zmat(i,k)=exp(-0.5*sqdist/(h**2.0))           
c    .. zmat contains kernel estimates at grid points

      implicit real (a-h, o-z)      
      dimension x(nr),y(nr),evalx(n),evaly(n),zmat(n,nr)

      do 10 i=1,n
         do 20 j=1,nr
            aux1=(evalx(i)-rx(j))**(2.0)
            aux2=(evaly(i)-ry(j))**(2.0)
            sqdist=aux1+aux2
            zmat(i,j)=exp(-0.5*sqdist/(h**2.0)) 
20       continue
10    continue

      return 
      end
      
