

      subroutine surv(h,hw,rx,ry,nr,evalx,evaly,n,zmat)

c    .. calculates the bivariate normal kernel
c         at n points (evalx,evaly)

c    .. inputs:
c    .. h is bandwidth
c    .. (rx,ry) is data
c    .. nr is no of data points
c    .. evalx is x-values of grid on which to compute estimate
c    .. evaly is y-values of grid on which to compute estimate
c    .. n is no of evaluation points

c    .. output:
c            zmat=exp(-0.5*sqdist/(h**2.0))           

      implicit real (a-h, o-z)      
      dimension hw(nr),rx(nr),ry(nr),evalx(n),evaly(n),zmat(n,nr)

      do 10 i=1,n 
         do 20 j=1,nr
            aux1=(evalx(i)-rx(j))**(2.0)
            aux2=(evaly(i)-ry(j))**(2.0)
            sqdist=aux1+aux2
            zmat(i,j)=exp(-0.5*sqdist/((h*hw(j))**2.0)) 
20       continue
10    continue
  
c This bit is done by surv4.f
c      do 30 i=1,n   
c         wf=0.0
c         do 40 j=0,nr-1
c            wf=wf+zmat(i,nr-j)
c            w1=zmat(i,nr-j)/wf
c            w2=1.0-(w1*st(nr-j))
c            zmat(i,nr-j)=w2
c 40      continue
c 30      continue

      return 
      end
      
