

      subroutine surv2(ncw,n,p,hv,rt,wd,wn,w,estim)

c    .. calculates the spatial quantile
c         at n points inside a grid

c    .. inputs:
c    .. ncw is the number of columns of w
c    .. n is no of evaluation points (number of rows of w)
c    .. p is the correspondent percentile of interest
c    .. hv is the smoothing parameter for the survival smoother
c          (default= 0.05)
c    .. rt is a vector with the observed survival times (not censored)
c    .. wd is a vector used in preliminar calculations
c    .. wn is a vector used in preliminar calculations
c    .. estim is a vector with zeros

c    .. output:
c    .. estim is a vector (nx1) with the estimated quantiles    

      implicit real (a-h, o-z)      
      dimension w(n,ncw),estim(n),rt(ncw-1),wd(ncw-1),wn(ncw-1)

      do 10 i=1,n 
         s0=0.0
         s1=0.0
         s2=0.0
         cJ=0.0
         aux3=0.0
         do 20 j=1,ncw-1
            aux1 = w(i,j)-w(i,j+1)
            cJ = cJ+aux1
            wd(j) = cJ-p
            wn(j)= exp(-0.5*((wd(j)/real(hv))**2.0))
            s0 = s0+wn(j)
            s1 = s1+(wn(j)*wd(j))
            s2 = s2+(wn(j)*(wd(j)**2.0))
 20      continue
         
         do 30 j=1,ncw-1
            aux2 = wn(j)*(s2-wd(j)*s1)
            aux2 = aux2/((s2*s0)-(s1**2.0))
            aux3 = aux3+(aux2*rt(j))
 30      continue
         
         estim(i) = aux3
 10   continue
      
      return 
      end
      








