

      subroutine surv4(nr,n,st,zmat)

c    .. inputs:
c    .. nr is no of data points
c    .. n is no of evaluation points
c    .. st are the survival times
c    .. zmat is the output from surv.f
c            it contains the bivariate normal kernel values

c    .. output:
c            zmat=1-(zmat/cumsum(zmat))*st           
c    .. zmat contains intermediate calculations for estimating weighted 
c    .. survival at grid points

      implicit real (a-h, o-z)      
      dimension st(nr),zmat(n,nr)

c   ..This bit is done by surv.f
c      do 10 i=1,n 
c         do 20 j=1,nr
c            aux1=(evalx(i)-rx(j))**(2.0)
c            aux2=(evaly(i)-ry(j))**(2.0)
c            sqdist=aux1+aux2
c            zmat(i,j)=exp(-0.5*sqdist/(h**2.0)) 
c20       continue
c10    continue
  
      do 30 i=1,n
         wf=0.0
         do 40 j=0,nr-1
            wf=wf+zmat(i,nr-j)
            if (wf.eq.0.0) then
               wf=1e-45
            end if
            w1=zmat(i,nr-j)/wf
            w2=1.0-(w1*st(nr-j))
            zmat(i,nr-j)=w2
 40      continue
 30      continue

      return 
      end
      
