

      subroutine surv6(ncw,n,w,zmat)

c    .. calculates the spatial quantile
c         at n points inside a grid

c    .. inputs:
c    .. ncw is the number of columns of w
c    .. n is no of evaluation points (number of rows of w)
c    .. p is the correspondent percentile of interest
c    .. hv is the smoothing parameter for the survival smoother
c          (default= 0.05)
c    .. rt is a vector with the observed survival times (not censored)
c    .. wd is a vector used in preliminar calculations
c    .. wn is a vector used in preliminar calculations
c    .. estim is a vector with zeros

c    .. output:
c    .. estim is a vector (nx1) with the estimated quantiles    

      implicit real (a-h, o-z)      
      dimension w(n,ncw),zmat(n,ncw-1)

      do 10 i=1,n 
         cJ=0.0
         do 20 j=1,ncw-1
            aux1 = w(i,j)-w(i,j+1)
            cJ = cJ+aux1
            zmat(i,j) = cJ
 20      continue
 10   continue
      
      return 
      end
      








